import ctypes
import numpy

def data_write_p(ni, nj, nk, data):
    print 'in Python'
    for k in range(nk):
        for j in range(nj):
            for i in range(ni):
                print i + 1, j + 1, k + 1, data[k][j][i]

def decl_fdata_pointer():
    lib.fdata_pointer.restypes = ctypes.c_void_p
    lib.fdata_pointer.argtypes = [
        ctypes.POINTER(ctypes.c_int),
        ctypes.POINTER(ctypes.c_int),
        ctypes.POINTER(ctypes.c_int)
    ]

def decl_pdata_recieve():
    lib.pdata_recieve.restypes = None
    lib.pdata_recieve.argtypes = [
        ctypes.POINTER(ctypes.c_int),
        ctypes.POINTER(ctypes.c_int),
        ctypes.POINTER(ctypes.c_int),
        numpy.ctypeslib.ndpointer(dtype=numpy.double, ndim=3)
    ]

lib = ctypes.CDLL("./libexampleFortran.so")

# simple test
bar = 1
lib.foo(ctypes.c_int(bar))


# multidimensional array test: Fortran -> Python
decl_fdata_pointer()

lib.fdata_allocate()

lib.data_write_f()

ni, nj, nk = ctypes.c_int(), ctypes.c_int(), ctypes.c_int()
fdp = lib.fdata_pointer(ctypes.byref(ni), ctypes.byref(nj), ctypes.byref(nk))
fdp = ctypes.cast(fdp, ctypes.POINTER(ctypes.c_double))
fdata = numpy.ctypeslib.as_array(fdp, shape=(nk.value, nj.value, ni.value))

data_write_p(ni.value, nj.value, nk.value, fdata)

i, j, k = 2, 3, 1
fdata[k - 1][j - 1][i - 1] = 2021

lib.data_write_f()

lib.fdata_deallocate()


# multidimensional array test: Python -> Fortran
decl_pdata_recieve()

pdata = numpy.empty((nk.value, nj.value, ni.value))

for k in range(nk.value):
    for j in range(nj.value):
        for i in range(ni.value):
            pdata[k][j][i] = (k + 1) * 100 + (j + 1) * 10 + (i + 1)

data_write_p(ni.value, nj.value, nk.value, pdata)

lib.pdata_recieve(ctypes.byref(ni), ctypes.byref(nj), ctypes.byref(nk), pdata)

lib.data_write_f()

lib.pdata_manipulate()

data_write_p(ni.value, nj.value, nk.value, pdata)
